//ColonnesPerso_302f.js
// 17.04.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Une (ou plusieurs) colonnes selon indication. L'espace restant est rpartie parmi les autres.

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

var curDoc = app.documents[0];

// mmoriser et tester l'unit de mesure horizontale 
// quand ce n'est pas 2053991795 (= des millimtres), changer  millimtres
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}

// initialiser d'autres variables
var curPage = app.activeWindow.activePage;
var leftChk = true;
var rghtChk = true;
var pWidth = curDoc.documentPreferences.pageWidth;
pWidth = Math.floor((pWidth * 1000) + 0.5) / 1000;
var curSpr = app.activeWindow.activeSpread;
var noMarginal = false;
var tC = "1";

// les marges gauche et droit
var pM = new Array (curPage.marginPreferences.left, curPage.marginPreferences.right);
// le nombre de colonnes
var nC = curPage.marginPreferences.columnCount;
// la liste des repres de colonne
var curPos = curPage.marginPreferences.columnsPositions;
var nPos = curPos.length;
// les valeurs du dcalage gauche et droit
var leftOff = curPos[0];
var leftOff2 = curPos[1];
var lastPos = curPos[nPos-1];
lastPos = Math.floor((lastPos * 1000) + 0.5) / 1000;
var rghtOff = (pWidth-pM[0]-pM[1])-lastPos;
rghtOff = Math.floor((rghtOff * 1000) + 0.5) / 1000;

// dsactiver les cases  cocher si la position est plus grande que la marge
if (pM[0] < (pM[0]+leftOff)) {
	leftChk = false;
}
if (pM[0] > (pM[0]+leftOff2)) {
	leftChk = false;
}
if (pM[1] < (pM[1]+rghtOff)) {
	rghtChk = false;
}

if (nPos == 2) {
	// la valeur "gouttire" actuelle
	var cG = curPage.marginPreferences.columnGutter;
	// une valeur par dfaut pour la colonne marginale
	var mWidth = "23";
}
else {
	// la valeur "gouttire" actuelle
	var cG = curPos[2]-curPos[1];
	// tenter de trouver la largeur et la position de la colonne marginale
	var mWidth = 9999;
	var curVal;
	for (var i=1; i<nPos; i=i+2) {
		curVal = curPos[i]-curPos[i-1];
		curVal = Math.floor((curVal * 1000) + 0.5) / 1000;
		if (curVal < mWidth) {
			mWidth = curVal;
			tC = "" + Math.floor(((i-1) / 2) + 1);
		}
	}
	if (mWidth != 9999) {
		tmpWidth = Math.floor((mWidth * 1000) + 0.5) / 1000;
		mWidth = "" + tmpWidth;
	}
	else {
		mWidth = "23";
		tC = "1";
	}
	if (tC == "1") {
		if (leftChk) {
			if (leftOff2 > 0) {
				mWidth = "" + ((mWidth*1) + leftOff);
			}
		}
	}
	if ((tC*1) == nC) {
		if (rghtChk) {
			mWidth = "" + ((mWidth*1) + rghtOff);
		}
	}
}

var curName = curPage.name;
var curParent = curPage.parent;

var isMaster = false;
if (curParent == "[object MasterSpread]") {
	isMaster = true;
}

var masNameList = new Array ();
var masPageList = new Array ();
masSpreads = curDoc.masterSpreads;
var nSpreads = masSpreads.length;
for (var s=0; s<nSpreads; s++) {
	masNameList.push(masSpreads[s].pages[0].name);
	nPag = masSpreads[s].pages.length;
	for (var p=0; p<nPag; p++) {
		actPage = masSpreads[s].pages[p].name + "" + (p+1);
		masPageList.push(actPage);
	}
}

// prparer le dialogue
var docList = curDoc.pages.everyItem().name;
var pageList = masPageList.concat(docList);
var propPage = -1;
var targetPage;
if (isMaster) {
	targetPage = (curSpr.pages.item(-1).name) + 1;
	for (var i=0; i<masPageList.length; i++) {
		if (masPageList[i] == targetPage) {
			propPage = i;
			break;
		}
		if (propPage == -1) {
			propPage = 0;
		}
	}
}
else {
	targetPage = curName;
	for (var i=0; i<pageList.length; i++) {
		if (pageList[i] == targetPage) {
			propPage = i;
			break;
		}
	}
		if (propPage == -1) {
		propPage = 0;
	}
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}
var labelWidth = 120; 
var aDialog = app.dialogs.add({name:"Des colonnes sur mesure"});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"La page cible", minWidth:130});
			var pageNames = dropdowns.add({stringList:pageList, selectedIndex:propPage});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Nombre de colonnes", minWidth:labelWidth});
					var columnNumberField = integerEditboxes.add({editValue:nC, minWidth:40});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Gouttire", minWidth:labelWidth});
					var columnGutterField = realEditboxes.add({editValue:cG, minWidth:40});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:30});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Retrait  gauche", minWidth:labelWidth});
					var leftOffsetField = realEditboxes.add({editValue:leftOff, minWidth:40});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:30});
				}
				with (dialogRows.add()) {
					var leftMarg = checkboxControls.add({staticLabel:"la 1re colonne commence au miroir", checkedState:leftChk});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Retrait  droite", minWidth:labelWidth});
					var rightOffsetField = realEditboxes.add({editValue:rghtOff, minWidth:40});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:30});
				}
				var rghtMarg = checkboxControls.add({staticLabel:"la dernire colonne touche le miroir", checkedState:rghtChk});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Colonne(s) marginale(s)..."});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					var marginalWidthField = textEditboxes.add({editContents:mWidth, minWidth:200});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"... en colonne(s) No", minWidth:labelWidth});
					var targetColumnField = textEditboxes.add({editContents:tC, minWidth:75});
				}
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:" ", minWidth:4});
	}
}
// montrer le dialogue et extraire les valeurs
var dResult = aDialog.show();
var targetMaster = false;
if (dResult == true) {
	var selPage = pageNames.selectedIndex;
	if ((selPage + 1) <= masPageList.length) {
		masNamePg = pageList[selPage];
		targetMaster = true;
	}
	else {
		selPage = selPage - masPageList.length;
	}
	var nCol = (columnNumberField.editValue)*1;
	var cGutter = columnGutterField.editValue;
	leftOff = leftOffsetField.editValue;
	var begFirst = leftMarg.checkedState;
	rghtOff = rightOffsetField.editValue;
	var endLast = rghtMarg.checkedState;
	var margVals = marginalWidthField.editContents;
	var tCol = targetColumnField.editContents;
}
else {
	aDialog.destroy();
	reStore();
	exit();
}
aDialog.destroy();

// tester quelques valeurs
if (nCol < 2) {
	alert ("Au moins deux colonnes.", "Stop");
	reStore();
	exit();
}
else {
	nC = nCol;
}
if ((pM[0] + leftOff) < 0) {
	alert ("Le retrait \" gauche\" est trop petit.", "Stop");
	reStore();
	exit();
}
if ((pM[1] + rghtOff) < 0) {
	alert ("Le retrait \" droite\" est trop petit.", "Stop");
	reStore();
	exit();
}
// examiner l'entre "colonne(s) marginale(s)"
if (margVals != "") {
	// supprimer des espaces superflues
	margVals = stripSpaces(margVals);
	// dtecter des signes invalides
	var nChars = margVals.length;
	var curChar;
	for (var i=0; i<nChars; i++) {
		curChar = margVals[i];
		if ("0123456789,. ".indexOf(curChar) == -1) {
			alert ("L'entre \"colonne(s) marginale(s)\" contient le signe invalide '" + curChar + "'", "Stop");
			reStore();
			exit();
		}
	}
	margVals = margVals.split(" ");
	var nMarg = margVals.length;
}
else {
	noMarginal = true;
	nMarg = 0;
}

// examiner l'entre "numro(s) de colonne(s)"
if (tCol != "") {
	// supprimer des espaces superflues
	tC = stripSpaces(tCol);
	// dtecter des signes invalides
	tChars = tC.length;
	var curChar;
	for (var i=0; i<tChars; i++) {
		curChar = tC[i];
		if ("0123456789 ".indexOf(curChar) == -1) {
			alert ("L'entre \"numro(s) de colonne(s)\" contient le signe invalide '" + curChar + "'", "Stop");
			reStore();
			exit();
		}
	}
	tC = tC.split(" ");
	var curItem;
	var oldColumn = 0;
	var nNbrs = tC.length;
	for (var i=0; i<nNbrs; i++) {
		curItem = tC[i]*1;
		if (curItem == 0) {
			alert ("La colonne No *zro* n'existe pas.\n\nEntre: " + tCol, "Stop");
			reStore();
			exit();
		}
		if (curItem == oldColumn) {
			alert ("Un numro de colonne ne peut tre attribu qu'*une* fois.\n\nEntre: " + tCol, "Stop");
			reStore();
			exit();
		}
		else if (curItem < oldColumn) {
			alert ("Entrer les numros de colonnes dans l'ordre *ascendant*.\n\nEntre: " + tCol, "Stop");
			reStore();
			exit();
		}
		else if (curItem > oldColumn) {
			oldColumn = curItem;
		}
	}
	if (nMarg != 0) {
		if (nMarg != nNbrs) {
			alert ("Le nombre des valeurs de colonnes et des colonnes cibles doivent correspondre.\n\nEntres: valeurs colonnes = " + nMarg + ", colonnes cibles = " + nNbrs, "Stop");
			reStore();
			exit();
		}
		if (tC[nNbrs-1]*1 > nC) {
			alert ("Le numro de colonne cible est plus grand que le nombre de colonnes.\n\nEntres: nombre de colonnes = " + nC + ", numro de colonne cible = " + tC[nNbrs-1], "Stop");
			reStore();
			exit();
		}
	}
	else {
		tC = 0;
		var nNbrs = 0;
	}
}
else {
	tC = 0;
	var nNbrs = 0;
	if (noMarginal == false) {
		alert ("Le champ *... en colonne(s) No* est vide.", "Stop");
		reStore();
		exit();
	}
}

// si la cible est un gabarit il faut mmoriser le nom et le chiffre
if (targetMaster) {
	var masName = masNamePg.slice(0,-1);
	var masPage = (masNamePg.slice(-1)*1)-1;
	var masInd = 0;
	var nMas = masNameList.length;
	for (var m=0; m<nMas; m++) {
		if (masName == masNameList[m]) {
			masInd = m;
			break;
		}
	}
}

// additionner les valeurs des colonnes marginales
var totMarginal = 0;
if (nMarg > 0) {
	for (var m=0; m<nMarg; m++) {
		totMarginal = totMarginal + (margVals[m])*1;
	}
}

// calculer la largeur de l'une des colonnes restantes
var nG = nC-1;
var cWidth = (pWidth - pM[0] - pM[1] - totMarginal) - (nG * cGutter);
if (begFirst == true && endLast == true) {
	cWidth = cWidth / (nC - nNbrs);
}
else if (begFirst == false && endLast == false) {
	cWidth = (cWidth - leftOff - rghtOff) / (nC - nNbrs);
}
else if (begFirst == true && endLast == false) {
	cWidth = (cWidth - rghtOff) / (nC - nNbrs);
}
else if (begFirst == false && endLast == true) {
	cWidth = (cWidth - leftOff) / (nC - nNbrs);
}
if (cWidth < 0.353) {
	alert ("Trop de colonnes ou gouttire trop grande.", "Stop");
	reStore();
	exit();
}

// lorsque le nombre de colonnes souhaites et le nombre de colonnes existantes ne correspondent pas
if (targetMaster) {
	curDoc.masterSpreads[masInd].pages.item(masPage).marginPreferences.columnCount = nC;
}
else {
	curDoc.pages[selPage].marginPreferences.columnCount = nC;
}

// appliquer la valeur  la gouttire
if (cGutter != cG) {
	if (targetMaster) {
		curDoc.masterSpreads[masInd].pages.item(masPage).marginPreferences.columnGutter = cGutter;
	}
	else {
		curDoc.pages[selPage].marginPreferences.columnGutter = cGutter;
	}
}

var cG = cGutter;
var mX = pM[0]+pM[1];
var pW = pWidth;
var cW = cWidth;

// la position du premier repre de colonne
var posA = leftOff;
// la position du dernier repre de colonne
var posZ = (pW - mX) - rghtOff;
if (begFirst == true) {
	var gPos = (posA - leftOff);
}
else {
	var gPos = posA;
}
var ctr = 0;
var curVal;
var posList = new Array();
posList.push(posA);
// une boucle pour assembler les valeurs
for (var n=1; n<nC; n++) {
	if (n == tC[ctr]*1) {
		curVal = margVals[ctr];
		mW = curVal*1;
		gPos = gPos + mW;
		ctr++;
	}
	else {
		gPos = gPos + cW;
	}
	posList.push(gPos);
	gPos = gPos + cG;
	posList.push(gPos);
}
posList.push(posZ);

// positionner les repres de colonne
if (targetMaster) {
	curDoc.masterSpreads[masInd].pages.item(masPage).marginPreferences.columnsPositions = posList;
}
else {
	curDoc.pages[selPage].marginPreferences.columnsPositions = posList;
}
reStore();

// la fonction qui supprime les espaces superflues (multiples, au dbut,  la fin)
function stripSpaces(str) {
	return str.replace(/\s+\s/g, ' ').replace(/^\s+/g, '').replace(/\s+$/g, '');
}

// rtablir l'unit de mesure (si ncessaire)
function reStore() {
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
}